/*
 * Chapter 12
 *
 * Adjust the brightness of the LED conencted to PA0 pin with the pushbutton on PB0 pin.
 *
 */

#include "../Headers/main.h"

int main(void)
{
    
	//Necessary variables
	int counter = 0;
	int duty = 0;
	
	//Initializing ports
    IOInit();

    //Infinite loop
    while (1)
    {
		//Managing counter
		if(counter < 10)
		{
			counter++;	
		}
		else
		{
			counter = 0;
		}
		
		//Part for handling the pushbutton
		//The pullup resistor keeps the input high in default state
		//When the button is pushed, it connects the input to ground, that must be detected
		if((PINB & 0x01) == 0)
		{
			//Increment duty, when the button is pushed
			duty++;
			//Switch off the LED while the button is pushed (brightness is adjusted) 
			PORTA = 0b0000000;
			//Wait while the button is pushed
			//We need to wait, because we want to increase the duty variable only once when the button is pressed
			while((PINB & 0x01) == 0);
		}
		
		//Reseting duty variable if needed
		if (duty >= 10)
		{
			duty = 0;
		}

		//Decide the current state of the LED
		if(counter < duty)
		{
			//Turn ON the LED
			PORTA = 0b0000001;
		}
		else
		{
			//Turn OFF the LED
			PORTA = 0b0000000;
		}
    }

    //Due to the Infinite loop, the software will never enter this region. However, this line is required by the compiler
    return 0;
}